class BrowserExtension

# class BrowserExtension | The Browser Extension is an extension (yes, no kidding) to KParts::ReadOnlyPart, which allows a better integration of parts with browsers (in particular Konqueror). More...
Full name | `KParts::BrowserExtension`
Definition | `#include <browserextension.h>`
Inherits | QObject (qt) [public ]
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Types

- typedef QMap ActionSlotMap
- typedef QMap ActionNumberMap

#### Public Methods

- BrowserExtension ( KParts::ReadOnlyPart *parent, const char *name = 0L )
- virtual ~BrowserExtension ()
- virtual void setURLArgs ( const URLArgs &args )
- URLArgs urlArgs () const
- virtual int xOffset ()
- virtual int yOffset ()
- virtual void saveState ( QDataStream &stream )
- virtual void restoreState ( QDataStream &stream )
- bool isURLDropHandlingEnabled () const
- void setURLDropHandlingEnabled ( bool enable )
- void setBrowserInterface ( BrowserInterface *impl )
- BrowserInterface * browserInterface () const
- bool isActionEnabled ( const char * name ) const

#### Signals

- void enableAction ( const char * name, bool enabled )
- void openURLRequest ( const KURL &url, const KParts::URLArgs &args = KParts::URLArgs() )
- void openURLRequestDelayed ( const KURL &url, const KParts::URLArgs &args = KParts::URLArgs() )
- void openURLNotify ()
- void setLocationBarURL ( const QString &url )
- void setIconURL ( const KURL &url )
- void createNewWindow ( const KURL &url, const KParts::URLArgs &args = KParts::URLArgs() )
- void createNewWindow ( const KURL &url, const KParts::URLArgs &args, const KParts::WindowArgs &windowArgs, KParts::ReadOnlyPart *&part )
- void loadingProgress ( int percent )
- void speedProgress ( int bytesPerSecond )
- void infoMessage ( const QString & )
- void popupMenu ( const QPoint &global, const KFileItemList &items )
- void popupMenu ( KXMLGUIClient *client, const QPoint &global, const KFileItemList &items )
- void popupMenu ( const QPoint &global, const KURL &url, const QString &mimeType, mode_t mode = (mode_t)-1 )
- void popupMenu ( KXMLGUIClient *client, const QPoint &global, const KURL &url, const QString &mimeType, mode_t mode = (mode_t)-1 )
- void selectionInfo ( const KFileItemList &items )
- void selectionInfo ( const QString &text )
- void selectionInfo ( const KURL::List &urls )
- void mouseOverInfo ( const KFileItem* item )

#### Public Static Methods

- static ActionSlotMap actionSlotMap ()
- static ActionSlotMap * actionSlotMapPtr ()
- static BrowserExtension * childObject ( QObject *obj )

#### Protected Methods

- virtual void virtual_hook ( int id, void* data )

## Detailed Description

The Browser Extension is an extension (yes, no kidding) to KParts::ReadOnlyPart, which allows a better integration of parts with browsers (in particular Konqueror). Remember that ReadOnlyPart only has openURL(KURL), with no other settings. For full-fledged browsing, we need much more than that, including many arguments about how to open this URL (see URLArgs), allowing parts to save and restore their data into the back/forward history, allowing parts to control the location bar URL, to requests URLs to be opened by the hosting browser, etc.

The part developer needs to define its own class derived from BrowserExtension, to implement the virtual methods [and the standard-actions slots, see below].

The way to associate the BrowserExtension with the part is to simply create the BrowserExtension as a child of the part (in QObject's terms). The hosting application will look for it automatically.

Another aspect of the browser integration is that a set of standard actions are provided by the browser, but implemented by the part (for the actions it supports).

The following standard actions are defined by the host of the view :

[selection-dependent actions]

- `cut` : Copy selected items to clipboard and store 'not cut' in clipboard.
- `copy` : Copy selected items to clipboard and store 'cut' in clipboard.
- `paste` : Paste clipboard into view URL.
- `pasteTo`(const KURL &) : Paste clipboard into given URL.
- `rename` : Rename item in place.
- `trash` : Move selected items to trash.
- `del` : Delete selected items (couldn't call it delete!).
- `shred` : Shred selected items (secure deletion).
- `properties` : Show file/document properties.
- `editMimeType` : show file/document's mimetype properties.

[normal actions]

- `print` : Print :-)
- `reparseConfiguration` : Re-read configuration and apply it.
- `refreshMimeTypes` : If the view uses mimetypes it should re-determine them.

The view defines a slot with the name of the action in order to implement the action. The browser will detect the slot automatically and connect its action to it when appropriate (i.e. when the view is active).

The selection-dependent actions are disabled by default and the view should enable them when the selection changes, emitting enableAction().

The normal actions do not depend on the selection. You need to enable 'print' when printing is possible - you can even do that in the constructor.

A special case is the configuration slots, not connected to any action directly, and having parameters.

[configuration slot]

- `setSaveViewPropertiesLocally`( bool ): If `true`, view properties are saved into .directory otherwise, they are saved globally.

BrowserExtension ( KParts::ReadOnlyPart *parent, const char *name = 0L ) | ### BrowserExtension

Constructor

Parameters:

parent | The KParts::ReadOnlyPart that this extension ... "extends" :)
name | An optional name for the extension.

~BrowserExtension () | ### ~BrowserExtension

[virtual]

void setURLArgs ( const URLArgs &args ) | ### setURLArgs

[virtual]

Set the parameters to use for opening the next URL. This is called by the "hosting" application, to pass parameters to the part.

See also: URLArgs

URLArgs urlArgs () | ### urlArgs

[const]

Retrieve the set of parameters to use for opening the URL (this must be called from openURL() in the part).

See also: URLArgs

int xOffset () | ### xOffset

[virtual]

Returns the current x offset.

For a scrollview, implement this using contentsX().

int yOffset () | ### yOffset

[virtual]

Returns the current y offset.

For a scrollview, implement this using contentsY().

void saveState ( QDataStream &stream ) | ### saveState

[virtual]

Used by the browser to save the current state of the view (in order to restore it if going back in navigation).

If you want to save additionnal properties, reimplement it but don't forget to call the parent method (probably first).

void restoreState ( QDataStream &stream ) | ### restoreState

[virtual]

Used by the browser to restore the view in the state it was when we left it.

If you saved additionnal properties, reimplement it but don't forget to call the parent method (probably first).

bool isURLDropHandlingEnabled () | ### isURLDropHandlingEnabled

[const]

Returns whether url drop handling is enabled. See setURLDropHandlingEnabled for more information about this property.

void setURLDropHandlingEnabled ( bool enable ) | ### setURLDropHandlingEnabled

Enables or disables url drop handling. URL drop handling is a property describing whether the hosting shell component is allowed to install an event filter on the part's widget, to listen for URI drop events. Set it to true if you are exporting a BrowserExtension implementation and do not provide any special URI drop handling. If set to false you can be sure to receive all those URI drop events unfiltered. Also note that the implementation as of Konqueror installs the event filter only on the part's widget itself, not on child widgets.

void setBrowserInterface ( BrowserInterface *impl ) | ### setBrowserInterface

BrowserInterface * browserInterface () | ### browserInterface

[const]

bool isActionEnabled ( const char * name ) | ### isActionEnabled

[const]

Returns: the status (enabled/disabled) of an action. When the enableAction signal is emitted, the browserextension stores the status of the action internally, so that it's possible to query later for the status of the action, using this method.

typedef QMap<QCString,QCString> ActionSlotMap | ### ActionSlotMap

ActionSlotMap actionSlotMap () | ### actionSlotMap

[static]

Returns a map containing the action names as keys and corresponding SLOT()'ified method names as data entries.

This is very useful for the host component, when connecting the own signals with the extension's slots. Basically you iterate over the map, check if the extension implements the slot and connect to the slot using the data value of your map iterator. Checking if the extension implements a certain slot can be done like this:

       extension->metaObject()->slotNames().contains( actionName + "()" )

(note that `actionName` is the iterator's key value if already iterating over the action slot map, returned by this method)

Connecting to the slot can be done like this:

       connect( yourObject, SIGNAL( yourSignal() ),
                extension, mapIterator.data() )

(where "mapIterator" is your QMap iterator)

ActionSlotMap * actionSlotMapPtr () | ### actionSlotMapPtr

[static]

Returns: a pointer to the static action-slot map. Preferred method to get it. The map is created if it doesn't exist yet

BrowserExtension * childObject ( QObject *obj ) | ### childObject

[static]

Queries `obj` for a child object which inherits from this BrowserExtension class. Convenience method.

void enableAction ( const char * name, bool enabled ) | ### enableAction

[signal]

Enables or disable a standard action held by the browser.

See class documentation for the list of standard actions.

void openURLRequest ( const KURL &url, const KParts::URLArgs &args = KParts::URLArgs() ) | ### openURLRequest

[signal]

Asks the host (browser) to open `url`. To set a reload, the x and y offsets, the service type etc., fill in the appropriate fields in the `args` structure. Hosts should not connect to this signal but to openURLRequestDelayed.

void openURLRequestDelayed ( const KURL &url, const KParts::URLArgs &args = KParts::URLArgs() ) | ### openURLRequestDelayed

[signal]

This signal is emitted when openURLRequest is called, after a 0-seconds timer. This allows the caller to terminate what it's doing first, before (usually) being destroyed. Parts should never use this signal, hosts should only connect to this signal.

void openURLNotify () | ### openURLNotify

[signal]

Tells the hosting browser that the part opened a new URL (which can be queried via KParts::Part::url().

This helps the browser to update/create an entry in the history. The part may not emit this signal together with openURLRequest(). Emit openURLRequest() if you want the browser to handle a URL the user asked to open (from within your part/document). This signal however is useful if you want to handle URLs all yourself internally, while still telling the hosting browser about new opened URLs, in order to provide a proper history functionality to the user. An example of usage is a html rendering component which wants to emit this signal when a child frame document changed its URL. Conclusion: you probably want to use openURLRequest() instead.

void setLocationBarURL ( const QString &url ) | ### setLocationBarURL

[signal]

Updates the URL shown in the browser's location bar to `url`.

void setIconURL ( const KURL &url ) | ### setIconURL

[signal]

Sets the URL of an icon for the currently displayed page.

void createNewWindow ( const KURL &url, const KParts::URLArgs &args = KParts::URLArgs() ) | ### createNewWindow

[signal]

Asks the hosting browser to open a new window for the given `url`.

The `args` argument is optional additionnal information for the browser,

See also: URLArgs

void createNewWindow ( const KURL &url, const KParts::URLArgs &args, const KParts::WindowArgs &windowArgs, KParts::ReadOnlyPart *&part ) | ### createNewWindow

[signal]

Asks the hosting browser to open a new window for the given `url` and return a reference to the content part. The request for a reference to the part is only fullfilled/processed if the serviceType is set in the `args` . (otherwise the request cannot be processed synchroniously.

void loadingProgress ( int percent ) | ### loadingProgress

[signal]

Since the part emits the jobid in the started() signal, progress information is automatically displayed.

However, if you don't use a KIO::Job in the part, you can use loadingProgress() and speedProgress() to display progress information.

void speedProgress ( int bytesPerSecond ) | ### speedProgress

[signal]

See also: loadingProgress

void infoMessage ( const QString & ) | ### infoMessage

[signal]

void popupMenu ( const QPoint &global, const KFileItemList &items ) | ### popupMenu

[signal]

Emit this to make the browser show a standard popup menu at the point `global` for the files `items`.

void popupMenu ( KXMLGUIClient *client, const QPoint &global, const KFileItemList &items ) | ### popupMenu

[signal]

Emit this to make the browser show a standard popup menu at the point `global` for the files `items`.

The GUI described by `client` is being merged with the popupmenu of the host

void popupMenu ( const QPoint &global, const KURL &url, const QString &mimeType, mode_t mode = (mode_t)-1 ) | ### popupMenu

[signal]

Emit this to make the browser show a standard popup menu at the point `global` for the given `url`.

Give as much information about this URL as possible, like the `mimeType` and the file type (`mode:` S_IFREG, S_IFDIR...)

void popupMenu ( KXMLGUIClient *client, const QPoint &global, const KURL &url, const QString &mimeType, mode_t mode = (mode_t)-1 ) | ### popupMenu

[signal]

Emit this to make the browser show a standard popup menu at the point `global` for the given `url`.

Give as much information about this URL as possible, like the `mimeType` and the file type (`mode:` S_IFREG, S_IFDIR...) The GUI described by `client` is being merged with the popupmenu of the host

void selectionInfo ( const KFileItemList &items ) | ### selectionInfo

[signal]

Inform the hosting application about the current selection. Used when a set of files/URLs is selected (with full information about those URLs, including size, permissions etc.)

void selectionInfo ( const QString &text ) | ### selectionInfo

[signal]

Inform the hosting application about the current selection. Used when some text is selected.

void selectionInfo ( const KURL::List &urls ) | ### selectionInfo

[signal]

Inform the hosting application about the current selection. Used when a set of URLs is selected.

void mouseOverInfo ( const KFileItem* item ) | ### mouseOverInfo

[signal]

Inform the hosting application that the user moved the mouse over an item. Used when the mouse is on an URL.

typedef QMap<QCString,int> ActionNumberMap | ### ActionNumberMap

void virtual_hook ( int id, void* data ) | ### virtual_hook

[protected virtual]

Generated by: root on macppc.ports.openbsd.org on Sat Sep 6 10:37:24 2003, using kdoc 2.0a54.